unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ToolWin, ComCtrls,LZRW1, ImgList;


type
  TPaker=class(TLzrw1)
   private
    FSciezka:string;//sciezka i nazwa pliku kompresji lub dekompresji
    FStrumienWejscia,
    FStrumienWyjscia:TMemoryStream;
   public
    property StrumienWejscia:TMemoryStream read FStrumienWejscia write FStrumienWejscia;
    property StrumienWyjscia:TMemoryStream read FStrumienWyjscia write FStrumienWyjscia;
    constructor Create(AOwner: TComponent;ASciezka:string);virtual;
    destructor Destroy;override;
    procedure Kompresja;
    procedure Dekompresja(var AListaDanych:TStringList);
  end;

  TForm1 = class(TForm)
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    OpenDialog1: TOpenDialog;
    ImageList1: TImageList;
    ToolButton3: TToolButton;
    SaveDialog1: TSaveDialog;
    Memo1: TMemo;
    procedure ToolButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ToolButton3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  ListaDanych:TStringList;
implementation

{$R *.DFM}
//***********METODY KLASY PAKERA****************
procedure TPaker.Dekompresja(var AListaDanych:TStringList);
begin
 FStrumienWejscia.LoadFromFile(FSciezka);
 FStrumienWejscia.Position:=0;
 UseStream:=true;
 InputStream :=FStrumienWejscia;
 OutputStream:=FStrumienWyjscia;
 Decompress;
 FStrumienWyjscia.Position:=0;
 AListaDanych.LoadFromStream(FStrumienWyjscia);
end;
procedure TPaker.Kompresja;
begin
 FStrumienWejscia.Position:=0;
 UseStream:=true;
 InputStream:=FStrumienWejscia;
 OutputStream:=FStrumienWyjscia;
 Compress;
 FStrumienWyjscia.Position:=0;
 FStrumienWyjscia.SaveToFile(FSciezka);
end;
constructor TPaker.Create(AOwner: TComponent;ASciezka:string);
begin
  inherited Create(AOwner);
  FSciezka:=ASciezka;
  FStrumienWejscia:=TMemoryStream.Create;
  FStrumienWyjscia:=TMemoryStream.Create;
end;
destructor TPaker.Destroy;
begin
   FStrumienWejscia.Free;
   FStrumienWyjscia.Free;
   inherited Destroy;
end;
//***********KONIEC KLASY PAKERA****************
procedure TForm1.ToolButton1Click(Sender: TObject);
var
   Paker: TPaker;
   i:LongWord;
   sciezka:string;
begin
   OpenDialog1.InitialDir:=ExtractFilePath(ParamStr(0));
   OpenDialog1.Filter:='Pliki tekstowe|*.txt';
   OpenDialog1.DefaultExt:='.OmegaPak';//'Pliki pakera Omegi|*.OmegaPak';
   //spakuj do
   if OpenDialog1.Execute then begin
      Memo1.Lines.Clear;

      Memo1.Lines.LoadFromFile(OpenDialog1.FileName);

      ListaDAnych.Clear;
      ListaDanych.LoadFromFile(OpenDialog1.FileName);
      sciezka:=ChangeFileExt(OpenDialog1.FileName, OpenDialog1.DefaultExt);
      Paker:=TPaker.Create(nil,sciezka);
      ListaDAnych.SaveToStream(Paker.StrumienWejscia);
      //spakuj do pliku o nazwie takiej samej jak otwarty ale zmienionym rozszerzeniu
      //na *.OmegaPak 
      Paker.Kompresja;

      Paker.Free;
   end;
end;
procedure TForm1.ToolButton3Click(Sender: TObject);
var
   Paker: TPaker;
   i:LongWord;
   sciezka:string;
begin
   OpenDialog1.InitialDir:=ExtractFilePath(ParamStr(0));
   OpenDialog1.Filter:='Pliki pakera Omegi|*.OmegaPak';
   OpenDialog1.DefaultExt:='.txt';//
   //rozpakuj do
   if OpenDialog1.Execute then begin
      Paker:=TPaker.Create(nil,OpenDialog1.FileName);
      ListaDAnych.Clear;
      Paker.Dekompresja(ListaDanych);
      //zaaduj zdekompresowane dane do Memo
      //stosujc odczyt linia po linii
      Memo1.Lines.Clear;
      for i:=0 to ListaDanych.Count-1do
      Memo1.Lines.Add(ListaDanych.Strings[i]);
      //sposb drugi duo szybszy
      {
      Paker.StrumienWyjscia.Position:=0;
      Memo1.Lines.Clear;
      Memo1.Lines.LoadFromStream(Paker.StrumienWyjscia);
      }

      Paker.Free;
   end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Randomize;
 Listadanych:=TStringList.Create;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Listadanych.Free;
end;


end.
